<template>
  <v-app>
    <HeaderBar v-if="authentified" :primaryDrawer="primaryDrawer"/>
    <v-content>
      <router-view class="pa-2"/>
    </v-content>
    <v-footer v-if="$store.getters['isMobile'] && $store.getters['listToLoad']" height="10vh" color="transaprent">
      <v-spacer></v-spacer>
      <v-btn color="error black--text" @click="$store.commit('deleteCurrent', true)" type="button">Delete list</v-btn>
      <v-spacer></v-spacer>
    </v-footer>
    <v-dialog v-model="serverUnreachable" persistent max-width="600px" >
      <v-flex xs12>
        <v-card class="elevation-20">
          <v-card-title height="50px" primary-title small class="blue text-uppercase justify-center">
            <div>
              <div class="headline">
                ERROR
              </div>
            </div>
          </v-card-title>
          <v-card-text class="text-md-center font-weight-bold subheading">
            SERVER UNAVAILABLE
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" @click="$store.commit('alert/serverUnreachable', false)">BACK</v-btn>
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-flex>
    </v-dialog>
    <notifications group="alert" position="bottom center" animation-type="velocity" :speed="500" ></notifications>
  </v-app>
</template>

<script>
import HeaderBar from '@/components/NavBar/HeaderBar'
import ErrorService from '@/services/ErrorService'
import { mapGetters } from 'vuex'

export default {
  name: 'App',
  components: {
    HeaderBar
  },

  computed: {
    ...mapGetters({
      authentified: 'auth/authenticated',
      serverUnreachable: 'alert/getServerUnreachable'
    })
  },

  data: () => ({
    errorService: new ErrorService(),
    primaryDrawer: {
      show: null,
      mini: false
    }
  }),

  created: function () {
    if (this.$store.state.alert.message) {
      this.$store.dispatch('alert/clear')
    }
    this.$store.watch(
      this.$store.getters['alert/getNumber'],
      (number) => {
        if (number > 0) {
          let msgs = this.$store.getters['alert/getMessages']
          for (let indice in msgs) {
            this.errorService.sendNotif(msgs[indice].type, msgs[indice].title, msgs[indice].content)
          }
          this.$store.dispatch('alert/clear')
        }
      },
      { deep: true }
    )
  },

  watch: {
    $route (to, from) {
      // clear alert on location change
      this.$store.dispatch('alert/clear')
    }
  }
}
</script>
